package demo;

import java.awt.BorderLayout ;
import java.awt.Frame ;

import javax.swing.JComponent ;
import javax.swing.JFrame ;
import javax.swing.JPanel ;
import javax.swing.JScrollPane ;
import javax.swing.JSplitPane ;


/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class DemosGallery extends JFrame {
  /**
   * static variable
   */
  private static DemosGallery gallery ;

  private static JSplitPane splitPane ;

  private JPanel displayPanel ;

  /**
   * private constructor,singleton pattern
   */
  private DemosGallery() {
  }

  /**
   * return instance object
   * @return a frame
   */
  public synchronized static DemosGallery getInstance() {
    if (gallery == null) {
      gallery = new DemosGallery() ;
    }

    return gallery ;
  }

  private void startUp() {
    this.setSize(600, 500) ;
    createUI() ;
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE) ;
    setVisible(true) ;
  }

  /**
   * create UI Component
   */
  private void createUI() {
    splitPane = new JSplitPane(1) ;
    JScrollPane jscrollpane = new JScrollPane(new DemosTree().getTree()) ;
    splitPane.setLeftComponent(jscrollpane) ;

    displayPanel = new JPanel(new BorderLayout()) ;
    splitPane.setRightComponent(displayPanel) ;

    getContentPane().setLayout(new BorderLayout()) ;
    getContentPane().add(splitPane, BorderLayout.CENTER) ;
  }

  public void setRightComponent(JComponent component) {
    displayPanel.removeAll() ;
    displayPanel.add(component) ;
    displayPanel.validate() ;
  }

  public static void main(String[] args) {
    DemosGallery newFrame = DemosGallery.getInstance() ;
    newFrame.setTitle("IJChart 1.0 Demos Gallery") ;

//    try {
//      UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel") ;
//    } catch (UnsupportedLookAndFeelException ex) {
//    } catch (IllegalAccessException ex) {
//    } catch (InstantiationException ex) {
//    } catch (ClassNotFoundException ex) {
//    }

    newFrame.startUp() ;
    newFrame.setExtendedState(Frame.MAXIMIZED_BOTH) ;
  }

}
