package demo.areacharts ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.StackedXYValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYStackedAreaRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StackedXYAreaChartDemo1 extends JPanel {

  public StackedXYAreaChartDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedXYAreaChart("Stacked XY Area Chart Demo 1", "X Value",
                                                          "Y Value", dataset,
                                                          ChartOrientation.VERTICAL, true,
                                                          true, false, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    xyplot.setDomainGridlinePaint(Color.white) ;
    xyplot.setValueGridlinePaint(Color.white) ;
    ((StackedXYValueAxis) xyplot.getDomainAxis()).setTickUnit(new LongTickUnit()) ;

    XYStackedAreaRender render = (XYStackedAreaRender) xyplot.getRender() ;
    render.setBackgroundPaint(Color.lightGray) ;

    render.setAutoSelectFillPaint(false) ;
    render.setRowItemFillPaint(0, Color.lightGray) ;
    render.setRowItemFillPaint(1, Color.red) ;

    xyplot.setDomainCrosshairVisible(true) ;
    xyplot.setValueCrosshairVisible(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;

    dataset.addRowData() ;
    dataset.addData(0, new XYNumberChartData(5D, 5D)) ;
    dataset.addData(0, new XYNumberChartData(10D, 15.5D)) ;
    dataset.addData(0, new XYNumberChartData(15D, 9.5D)) ;
    dataset.addData(0, new XYNumberChartData(20D, 7.5D)) ;

    dataset.addRowData() ;
    dataset.addData(1, new XYNumberChartData(5D, 5D)) ;
    dataset.addData(1, new XYNumberChartData(10D, 15.5D)) ;
    dataset.addData(1, new XYNumberChartData(15D, 9.5D)) ;
    dataset.addData(1, new XYNumberChartData(20D, 3.5D)) ;

    return dataset ;
  }

}
