package demo.barcharts.category ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Bar2DRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class BarChartDemo8 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public BarChartDemo8() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createCategoryBar2DChart(
      "Bar Chart Demo 8", "Category", "Value", dataset, orientation, false, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    NumberValueAxis numberaxis = (NumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;

    Bar2DRender render = (Bar2DRender) plot.getRender() ;
    render.setBaseItemLabelVisible(true) ;
    render.setColumnItemLabelVisible(1, false) ;
    render.setColumnItemLabelVisible(2, false) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_TOP) ;

    CategoryAxis categoryaxis = plot.getCategoryAxis() ;
    categoryaxis.setTickLabelAngle(IAngle.ANGLE_UP_45) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("First") ;
    dataset.addColKey("Second") ;
    dataset.addColKey("Third") ;

    for (int i = 1 ; i <= 5 ; i++) {
      dataset.addRowKey("Category " + i) ;
    }

    double data[][] = { {1.0D, 4D, 3D, 5D, 5D}, {5D, 7D, 6D, 8D, 4D}, {4D, 3D, 2D, 3D, 6D}
    } ;
    dataset.addRowData(5) ;

    for (int i = 0 ; i < 5 ; i++) {
      for (int j = 0 ; j < data.length ; j++) {
        dataset.addData(i, new NumberChartData(data[j][i])) ;
      }
    }

    return dataset ;
  }

}
