package demo.barcharts.category ;

import java.awt.BasicStroke ;
import java.awt.Color ;
import java.awt.Font ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.annotation.CategoryTextAnnotation ;
import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Bar2DRender ;
import com.ijchart.xychart.title.TextTitle ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class SurveyResultsDemo1 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.HORIZONTAL ;

  public SurveyResultsDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createCategoryBar2DChart(
      "Figure 7 | I. Resources - The site offers users relevant, informative and educational resources", null, null,
      dataset, orientation, true, true) ;

    TextTitle title = (TextTitle) chart.getTitle() ;
    title.setHorizontalAlignment(HorizontalAlignment.LEFT) ;
    title.setFillBackground(true) ;
    title.setBackgroundPaint(Color.red) ;
    title.setTextPaint(Color.white) ;
    title.setTextFont(new Font("SansSerif", Font.BOLD, 11));

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setDomainGridlineStroke(new BasicStroke(0.5F)) ;
    plot.setDomainGridlinePaint(Color.black) ;
    plot.setValueGridlineVisible(false) ;

    CategoryAxis categoryaxis = plot.getCategoryAxis() ;
    categoryaxis.setVisible(false) ;
    categoryaxis.setCategoryMargin(0.3D) ;
    plot.getValueAxis().setVisible(false) ;

    Bar2DRender barrenderer = (Bar2DRender) plot.getRender() ;
    barrenderer.setAutoSelectFillPaint(false) ;
    barrenderer.setColumnItemFillPaint(0, new Color(156, 164, 74)) ;
    CategoryTextAnnotation categorytextannotation = new CategoryTextAnnotation(
      "1. White papers are available.", "Category 1", 0.0D) ;
    categorytextannotation.setTextFont(new Font("SansSerif", 1, 12)) ;
    categorytextannotation.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(categorytextannotation) ;

    CategoryTextAnnotation annotation1 = new CategoryTextAnnotation("2. White papers enhance users understanding of the firm and its expertise.", "Category 2", 0.0D);
    annotation1.setTextFont(new Font("SansSerif", 0, 12));
    annotation1.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation1);
    CategoryTextAnnotation annotation2 = new CategoryTextAnnotation("3. White papers are relevant to the firm's prospects and clients.", "Category 3", 0.0D);
    annotation2.setTextFont(new Font("SansSerif", 0, 12));
    annotation2.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation2);
    CategoryTextAnnotation annotation3 = new CategoryTextAnnotation("4. White papers are relevant to the firm's positioning.", "Category 4", 0.0D);
    annotation3.setTextFont(new Font("SansSerif", 0, 12));
    annotation3.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation3);
    CategoryTextAnnotation annotation4 = new CategoryTextAnnotation("5. Case studies are available.", "Category 5", 0.0D);
    annotation4.setTextFont(new Font("SansSerif", 1, 12));
    annotation4.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation4);
    CategoryTextAnnotation annotation5 = new CategoryTextAnnotation("6. Case studies enhance users understanding of the firm and its expertise.", "Category 6", 0.0D);
    annotation5.setTextFont(new Font("SansSerif", 0, 12));
    annotation5.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation5);
    CategoryTextAnnotation annotation6 = new CategoryTextAnnotation("7. Case studies are relevant to the firm's prospects and clients.", "Category 7", 0.0D);
    annotation6.setTextFont(new Font("SansSerif", 0, 12));
    annotation6.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation6);
    CategoryTextAnnotation annotation7 = new CategoryTextAnnotation("8. White papers are relevant to the firm's positioning.", "Category 8", 0.0D);
    annotation7.setTextFont(new Font("SansSerif", 0, 12));
    annotation7.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation7);
    CategoryTextAnnotation annotation8 = new CategoryTextAnnotation("9. Case studies are available.", "Category 9", 0.0D);
    annotation8.setTextFont(new Font("SansSerif", 1, 12));
    annotation8.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation8);
    CategoryTextAnnotation annotation9 = new CategoryTextAnnotation("10. Case studies enhance users understanding of the firm and its expertise.", "Category 10", 0.0D);
    annotation9.setTextFont(new Font("SansSerif", 0, 12));
    annotation9.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation9);
    CategoryTextAnnotation annotation10 = new CategoryTextAnnotation("11. Case studies are relevant to the firm's prospects and clients.", "Category 11", 0.0D);
    annotation10.setTextFont(new Font("SansSerif", 0, 12));
    annotation10.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation10);
    CategoryTextAnnotation annotation11 = new CategoryTextAnnotation("12. White papers are relevant to the firm's positioning.", "Category 12", 0.0D);
    annotation11.setTextFont(new Font("SansSerif", 0, 12));
    annotation11.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation11);
    CategoryTextAnnotation annotation12 = new CategoryTextAnnotation("13. Users can easily access resources based on viewer interest.", "Category 13", 0.0D);
    annotation12.setTextFont(new Font("SansSerif", 1, 12));
    annotation12.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation12);
    CategoryTextAnnotation annotation13 = new CategoryTextAnnotation("14. Access to additional hyperlinks enhances users's ability to find relevant information.", "Category 14", 0.0D);
    annotation13.setTextFont(new Font("SansSerif", 1, 12));
    annotation13.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation13);
    CategoryTextAnnotation annotation14 = new CategoryTextAnnotation("15. OVERALL EFFECTIVENESS.", "Overall", 0.0D);
    annotation14.setTextFont(new Font("SansSerif", 1, 12));
    annotation14.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    barrenderer.addAnnotation(annotation14);

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    for (int i = 1 ; i <= 14 ; i++) {
      dataset.addRowKey("Category " + i) ;
    }
    dataset.addRowKey("Overall") ;
    dataset.addColKey("Results") ;

    double data[] = {2.0099999999999998D, 2.02D, 2D, 1.97D, 1.4399999999999999D, 1.49D, 1.49D,
                    1.48D, 4.2599999999999998D, 4.0800000000000001D, 4.0300000000000002D,
                    3.9199999999999999D, 3.9900000000000002D, 2.23D, 2.6000000000000001D
    } ;

    dataset.addRowData(data.length) ;
    for (int i = 0 ; i < data.length ; i++) {
      dataset.addData(i, new NumberChartData(data[i])) ;
    }

    return dataset ;
  }

}
