package demo.linecharts ;

import java.awt.BasicStroke ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYStepLineRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYStepRendererDemo1 extends JPanel {

  private ChartOrientation horizontal = ChartOrientation.VERTICAL ;

  private IMatrixDataset dataset = createDataset1() ;

  public XYStepRendererDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IJChart chart = ChartFactory.createXYStepLineChart(
      "XYStepRenderer Demo 1", "X", "Y", dataset, horizontal, true, true, false, false) ;

    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    XYStepLineRender render = (XYStepLineRender) xyplot.getRender() ;
    render.setRowItemBorderStroke(0, new BasicStroke(2.0F)) ;
    render.setRowItemBorderStroke(1, new BasicStroke(2.0F)) ;

    XYNumberValueAxis domainaxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    domainaxis.setAxisRangeIncludeZero(false) ;
    domainaxis.setTickUnit(new LongTickUnit()) ;
    domainaxis.setLowerMargin(0.02) ;
    domainaxis.setUpperMargin(0.02) ;

    XYNumberValueAxis numberaxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;
    numberaxis.setUpperMargin(0.02) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;

    dataset.addRowData(2) ;
    dataset.addData(0, new XYNumberChartData(1.0D, 3D)) ;
    dataset.addData(0, new XYNumberChartData(2D, 4D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 2D)) ;
    dataset.addData(0, new XYNumberChartData(6D, 3D)) ;

    dataset.addData(1, new XYNumberChartData(1.0D, 7D)) ;
    dataset.addData(1, new XYNumberChartData(2D, 6D)) ;
    dataset.addData(1, new XYNumberChartData(3D, 9D)) ;
    dataset.addData(1, new XYNumberChartData(4D, 5D)) ;
    dataset.addData(1, new XYNumberChartData(6D, 4D)) ;

    return dataset ;
  }

}
