package demo.miscellaneous.annotations ;

import java.awt.Color ;
import java.awt.GridLayout ;
import java.awt.geom.GeneralPath ;

import javax.swing.JPanel ;

import com.ijchart.xychart.annotation.XYShapeAnnotation ;
import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYPolygonAnnotationDemo1 extends JPanel {
  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  public XYPolygonAnnotationDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createScatterChart("XYPolygonAnnotationDemo1", "X", "Y", dataset,
                                                    vertical, true, true, false, false) ;

    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    xyplot.setDomainGridlinePaint(Color.white) ;
    xyplot.setValueGridlinePaint(Color.white) ;
    xyplot.getDomainAxis().setUpperMargin(0.02D) ;
    xyplot.getValueAxis().setUpperMargin(0.02D) ;

    XYNumberValueAxis xAxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    xAxis.setAxisRangeIncludeZero(false) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;

//    Polygon polygon = new Polygon(new int[] {2, 3, 4, 2}, new int[] {5, 8, 5, 2}, 4) ;
//    Polygon polygon = new Polygon(new int[] {2, 6, 4, 3}, new int[] {5, 8, 5, 2}, 4) ;
    GeneralPath path = new GeneralPath() ;
    path.moveTo(2, 5) ;
    path.lineTo(2.5F, 8F) ;
    path.lineTo(3, 5) ;
    path.lineTo(2.5F, 2) ;
    path.closePath() ;

    XYShapeAnnotation annotation = new XYShapeAnnotation(path) ;
    annotation.setFillPaint(new Color(200, 200, 255, 100)) ;
    annotation.setBorderStroke(null) ;
    render.addAnnotation(annotation) ;

//    XYPolygonAnnotation xypolygonannotation = new XYPolygonAnnotation (new double[] {2D, 5D, 2.5D, 8D, 3D, 5D, 2.5D, 2D
//   }, null, null, new Color (200, 200, 255, 100)) ;


    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;
    dataset.addRowData(2) ;

    double data1[][] = { {1.7D, 2.2000000000000002D, 2.7000000000000002D, 3D, 3.2000000000000002D},
                       {4D, 3D, 6D, 1.0D, 9D}
    } ;

    double data2[][] = { {2.1000000000000001D, 2.2000000000000002D, 2.3999999999999999D,
                       2.7000000000000002D, 3.2000000000000002D}
                       , {4.5D, 6D, 4D, 8D, 5.0999999999999996D}
    } ;

    for (int i = 0 ; i < data1[0].length ; i++) {
      dataset.addData(0, new XYNumberChartData(data1[0][i], data1[1][i])) ;
    }

    for (int i = 0 ; i < data2[0].length ; i++) {
      dataset.addData(1, new XYNumberChartData(data2[0][i], data2[1][i])) ;
    }

    return dataset ;
  }

}
