package demo.multipleaxischarts ;

import java.awt.GridLayout ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.RenderDrawOrder ;
import com.ijchart.xychart.constant.XYValueAxisType ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class DualAxisDemo2 extends JPanel {
  private Calendar cal = Calendar.getInstance() ;

  public DualAxisDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IJChart chart = createChart() ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private IJChart createChart() {
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Dual Axis Chart", "Category", "Value",
                                                           createDataset1(),
                                                           ChartOrientation.VERTICAL,
                                                           true, true, true, false) ;
    chart.getLegendTitle().setBorderVisible(false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;

    IMatrixDataset dataset2 = createDataset2() ;
    XYLineAndShapeRender shapeRender = new XYLineAndShapeRender(dataset2) ;
    plot.setRender(1, shapeRender) ;

    XYNumberValueAxis numberaxis = new XYNumberValueAxis("Secondary", dataset2,
                                                         XYValueAxisType.XY_VALUE_AXIS_Y) ;
    numberaxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    plot.setValueAxis(1, numberaxis) ;
    plot.setRenderDrawOrder(RenderDrawOrder.FORWARD) ;

    return chart ;
  }

  private IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Random Data 1") ;
    dataset.addRowData() ;

    dataset.addData(0, new XYNumberChartData(dateToTime(2, 2001), 181.80000000000001D));
    dataset.addData(0, new XYNumberChartData(dateToTime(3, 2001), 167.30000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(4, 2001), 153.80000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(5, 2001), 167.59999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(6, 2001), 158.80000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(7, 2001), 148.30000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(8, 2001), 153.90000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(9, 2001), 142.69999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(10, 2001), 123.2D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(11, 2001), 131.80000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(12, 2001), 139.59999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(1, 2002), 142.90000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(2, 2002), 138.69999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(3, 2002), 137.30000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(4, 2002), 143.90000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(5, 2002), 139.80000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(6, 2002), 137D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(7, 2002), 132.80000000000001D)) ;

    return dataset ;
  }

  private long dateToTime(int month, int year) {
    cal.set(year, month - 1, 1, 8, 0, 0) ;
    return cal.getTime().getTime() ;
  }

  private IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Random Data 2") ;
    dataset.addRowData() ;

    dataset.addData(0, new XYNumberChartData(dateToTime(2, 2001), 429.60000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(3, 2001), 323.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(4, 2001), 417.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(5, 2001), 624.10000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(6, 2001), 422.60000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(7, 2001), 619.20000000000005D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(8, 2001), 416.5D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(9, 2001), 512.70000000000005D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(10, 2001), 501.5D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(11, 2001), 306.10000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(12, 2001), 410.30000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(1, 2002), 511.69999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(2, 2002), 611D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(3, 2002), 709.60000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(4, 2002), 613.20000000000005D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(5, 2002), 711.60000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(6, 2002), 708.79999999999995D)) ;
    dataset.addData(0, new XYNumberChartData(dateToTime(7, 2002), 724.60000000000002D)) ;

    return dataset ;
  }

}
