package demo.multipleaxischarts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.AxisLocation ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.RenderDrawOrder ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.LineAndShapeRender ;
import com.ijchart.xychart.ui.RectangleEdge ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class DualAxisDemo3 extends JPanel {
  public DualAxisDemo3() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IJChart chart = ChartFactory.createCategoryBar2DChart("Dual Axis Chart", "Category", "Value",
                                                          createDataset1(),
                                                          ChartOrientation.HORIZONTAL, true, true) ;
    chart.getLegendTitle().setPosition(RectangleEdge.LEFT) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setCategoryAxisLocation(AxisLocation.BOTTOM_OR_RIGHT) ;
    plot.getCategoryAxis().setAxisLabelAngle(IAngle.ANGLE_DOWN_90) ;

    IMatrixDataset dataset2 = createDataset2() ;
    LineAndShapeRender shapeRender = new LineAndShapeRender(dataset2) ;
    plot.setRender(1, shapeRender) ;

    NumberValueAxis numberaxis = new NumberValueAxis("Secondary", dataset2) ;
    plot.setValueAxis(1, numberaxis) ;
    plot.setRenderDrawOrder(RenderDrawOrder.FORWARD) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    String s = "First" ;
    String s1 = "Second" ;
    String s2 = "Third" ;
    String s3 = "Category 1" ;
    String s4 = "Category 2" ;
    String s5 = "Category 3" ;
    String s6 = "Category 4" ;
    String s7 = "Category 5" ;
    String s8 = "Category 6" ;
    String s9 = "Category 7" ;
    String s10 = "Category 8" ;

    dataset.addColKey(s) ;
    dataset.addColKey(s1) ;
    dataset.addColKey(s2) ;

    dataset.addRowKey(s3) ;
    dataset.addRowKey(s4) ;
    dataset.addRowKey(s5) ;
    dataset.addRowKey(s6) ;
    dataset.addRowKey(s7) ;
    dataset.addRowKey(s8) ;
    dataset.addRowKey(s9) ;
    dataset.addRowKey(s10) ;

    dataset.addRowData(8) ;

    dataset.addData(0, new NumberChartData(1.0D)) ;
    dataset.addData(1, new NumberChartData(4D)) ;
    dataset.addData(2, new NumberChartData(3D)) ;
    dataset.addData(3, new NumberChartData(5D)) ;
    dataset.addData(4, new NumberChartData(5D)) ;
    dataset.addData(5, new NumberChartData(7D)) ;
    dataset.addData(6, new NumberChartData(7D)) ;
    dataset.addData(7, new NumberChartData(8D)) ;
    dataset.addData(0, new NumberChartData(5D)) ;
    dataset.addData(1, new NumberChartData(7D)) ;
    dataset.addData(2, new NumberChartData(6D)) ;
    dataset.addData(3, new NumberChartData(8D)) ;
    dataset.addData(4, new NumberChartData(4D)) ;
    dataset.addData(5, new NumberChartData(4D)) ;
    dataset.addData(6, new NumberChartData(2D)) ;
    dataset.addData(7, new NumberChartData(1.0D)) ;
    dataset.addData(0, new NumberChartData(4D)) ;
    dataset.addData(1, new NumberChartData(3D)) ;
    dataset.addData(2, new NumberChartData(2D)) ;
    dataset.addData(3, new NumberChartData(3D)) ;
    dataset.addData(4, new NumberChartData(6D)) ;
    dataset.addData(5, new NumberChartData(3D)) ;
    dataset.addData(6, new NumberChartData(4D)) ;
    dataset.addData(7, new NumberChartData(3D)) ;

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    String s = "Fourth" ;
    String s1 = "Category 1" ;
    String s2 = "Category 2" ;
    String s3 = "Category 3" ;
    String s4 = "Category 4" ;
    String s5 = "Category 5" ;
    String s6 = "Category 6" ;
    String s7 = "Category 7" ;
    String s8 = "Category 8" ;

    dataset.addRowKey(s) ;

    dataset.addColKey(s1) ;
    dataset.addColKey(s2) ;
    dataset.addColKey(s3) ;
    dataset.addColKey(s4) ;
    dataset.addColKey(s5) ;
    dataset.addColKey(s6) ;
    dataset.addColKey(s7) ;
    dataset.addColKey(s8) ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(15D)) ;
    dataset.addData(0, new NumberChartData(24D)) ;
    dataset.addData(0, new NumberChartData(31D)) ;
    dataset.addData(0, new NumberChartData(25D)) ;
    dataset.addData(0, new NumberChartData(56D)) ;
    dataset.addData(0, new NumberChartData(37D)) ;
    dataset.addData(0, new NumberChartData(77D)) ;
    dataset.addData(0, new NumberChartData(18D)) ;

    return dataset ;
  }

}
