package demo.others.shapes;

import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Font ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Rectangle2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.TextDirection ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.constant.VerticalAlignment ;
import com.ijchart.xychart.shape.RectangleTextChartShape ;
import com.ijchart.xychart.util.TextUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class RectangleTextChartShapePanel3 extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  public RectangleTextChartShapePanel3() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(1, 2)) ;
    addPanel1() ;
    addPanel2() ;

    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    final RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(70, 10, 200, 14.310302343750001),
                                  "25.033", new Font("SansSerif", Font.PLAIN, 10)) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.INSIDE) ;
    text.setTextVerticalAlign(VerticalAlignment.CENTER) ;
    text.setTextHorizontalAlign(HorizontalAlignment.CENTER) ;
    text.setTextDirection(TextDirection.HORIZONTAL) ;
    text.setDrawBorder(true) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        text.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + text.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;

  }

  private void addPanel2() {
    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        g2.setFont(new Font("SansSerif", Font.PLAIN, 10)) ;
        g2.translate(30, 30) ;
        String str = "12345abcdefgj" ;
        g2.drawString(str, 0, 0) ;
        Rectangle2D rect = TextUtil.getStringBoundWithFm(g2, str) ;
        g2.draw(rect) ;

//        g2.setPaint(Color.red) ;
//        g2.drawLine(0, 0, 100, 0) ;

//        FontMetrics fm = g2.getFontMetrics() ;
//        Rectangle2D rect = new Rectangle2D.Double(0, -fm.getAscent()+fm.getDescent(), fm.stringWidth(str),
//                                                  fm.getHeight()-2*fm.getDescent()) ;
//        g2.draw(rect) ;
      }
    } ;

    panel.setPreferredSize(new Dimension(110, 110)) ;
    add(panel) ;
  }
}
