package demo.others.xy ;

import java.awt.BasicStroke ;
import java.awt.Font ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.label.ILabelGenerator ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.AbstractXYRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYStepLineChartPanel2 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public XYStepLineChartPanel2() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;
//    addPanel2() ;
//    addPanel3() ;
//    addPanel4() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createXYStepLineChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, false, false) ;

    setChartLabelXY(chart) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractXYRender xyRender = plot.getRender() ;
    xyRender.setRowItemBorderStroke(0, new BasicStroke(2.0F)) ;
    xyRender.setRowItemBorderStroke(1, new BasicStroke(2.0F)) ;
    xyRender.setBaseItemLabelFont(new Font("Dialog", 1, 14)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createXYStepLineChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractXYRender xyRender = plot.getRender() ;
    xyRender.setRowItemBorderStroke(0, new BasicStroke(2.0F)) ;
    xyRender.setRowItemBorderStroke(1, new BasicStroke(2.0F)) ;
    xyRender.setBaseItemLabelFont(new Font("Dialog", 1, 14)) ;

    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.05) ;
    setChartLabelXY(chart) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createXYStepLineChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, false, false) ;

    setChartLabelXY(chart) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractXYRender xyRender = plot.getRender() ;
    xyRender.setRowItemBorderStroke(0, new BasicStroke(1.5F)) ;
    xyRender.setRowItemBorderStroke(1, new BasicStroke(2.5F)) ;

    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createXYStepLineChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, false, false) ;

    setChartLabelXY(chart) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractXYRender xyRender = plot.getRender() ;
    xyRender.setRowItemBorderStroke(0, new BasicStroke(1.0F)) ;
    xyRender.setRowItemBorderStroke(1, new BasicStroke(4.0F)) ;

    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static void setChartLabelXY(IJChart chart) {
    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractXYRender render = plot.getRender() ;
    ILabelGenerator labelGenerator = new DefaultLabelGenerator(null) ;

    render.setLabelGenerator(labelGenerator) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Col1") ;
    dataset.addColKey("Col2") ;
    dataset.addColKey("Col3") ;
    dataset.addColKey("Col4") ;

    dataset.addRowKey("Row1") ;
    dataset.addRowKey("Row2") ;

    dataset.addRowData() ;
    dataset.addData(0, new XYNumberChartData(1.0D, 3D)) ;
    dataset.addData(0, new XYNumberChartData(2D, 4D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 2D)) ;
    dataset.addData(0, new XYNumberChartData(6D, 3D)) ;

    dataset.addRowData() ;
    dataset.addData(1, new XYNumberChartData(1.0D, 7D)) ;
    dataset.addData(1, new XYNumberChartData(2D, 6D)) ;
    dataset.addData(1, new XYNumberChartData(3D, 9D)) ;
    dataset.addData(1, new XYNumberChartData(4D, 5D)) ;
    dataset.addData(1, new XYNumberChartData(6D, 4D)) ;

    return dataset ;
  }

}
