package demo.others.xycharts;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class DotDemo2 extends JPanel {
  private IMatrixDataset dataset ;

  public DotDemo2() {
    dataset = createDataset() ;
    createPanel1() ;
  }

  public void createPanel1() {
    IJChart chart = createChart() ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private IJChart createChart() {
    IJChart chart = ChartFactory.createXYDotChart(
      "XY Series Demo 3", "X", "Y", dataset, ChartOrientation.HORIZONTAL,
      true, true, false, false) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset ds = new DefaultMatrixDataset() ;

    for (int k = 0 ; k < 4 ; k++) {
      ds.addRowData() ;
      ds.addRowKey("Series " + (k + 1)) ;

      for (int l = 0 ; l < 40 ; l++) {
        double d4 = (Math.random() - 0.5D) * 200D ;
        double d5 = (Math.random() + 0.5D) * 6D * d4 + d4 ;

        ds.addData(k, new XYNumberChartData(d4, d5)) ;
      }
    }

    return ds ;
  }

}
