package demo.overlaidcharts ;

import java.awt.Color ;
import java.awt.GridLayout ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.constant.XYValueAxisType ;
import com.ijchart.xychart.data.IntervalXYNumberChartData ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.NumberChartDataFormatter ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYIntervalBar2DRender ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class OverlaidXYPlotDemo1 extends JPanel {
  private Calendar cal = Calendar.getInstance() ;

  private final long one_day = 24 * 60 * 60 * 1000 ;

  public OverlaidXYPlotDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IJChart chart = createChart() ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private IJChart createChart() {
    IMatrixDataset dataset1 = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXYBar2DChart("Overlaid XYPlot Demo 1", "Date",
                                                            "Value", dataset1,
                                                            ChartOrientation.VERTICAL,
                                                            true, true, true, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.setDomainGridlinePaint(Color.white) ;
    plot.setValueGridlinePaint(Color.white) ;

    XYIntervalBar2DRender render = (XYIntervalBar2DRender) plot.getRender() ;
    render.setLabelGenerator(new DefaultLabelGenerator(new NumberChartDataFormatter("#0"))) ;
    render.setBaseItemLabelVisible(true) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_TOP) ;

    IMatrixDataset dataset2 = createDataset2() ;
    XYNumberValueAxis valueAxis2 = new XYNumberValueAxis("Value", dataset2,
                                                         XYValueAxisType.XY_VALUE_AXIS_Y) ;
    valueAxis2.setUpperMargin(0.02) ;
    valueAxis2.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    plot.setValueAxis(0, valueAxis2) ;

    XYLineAndShapeRender render2 = new XYLineAndShapeRender(dataset2) ;
    render2.setRowItemShapeVisible(0, false) ;
    plot.setRender(1, render2) ;

    return chart ;
  }

  private IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;

    dataset.addRowData() ;

    dataset.addData(0, createData(toLongTime(1, 3, 2002), 12353.299999999999D)) ;
    dataset.addData(0, createData(toLongTime(2, 3, 2002), 13734.4D)) ;
    dataset.addData(0, createData(toLongTime(3, 3, 2002), 14525.299999999999D)) ;
    dataset.addData(0, createData(toLongTime(4, 3, 2002), 13984.299999999999D)) ;
    dataset.addData(0, createData(toLongTime(5, 3, 2002), 12999.4D)) ;
    dataset.addData(0, createData(toLongTime(6, 3, 2002), 14274.299999999999D)) ;
    dataset.addData(0, createData(toLongTime(7, 3, 2002), 15943.5D)) ;
    dataset.addData(0, createData(toLongTime(8, 3, 2002), 14845.299999999999D)) ;
    dataset.addData(0, createData(toLongTime(9, 3, 2002), 14645.4D)) ;
    dataset.addData(0, createData(toLongTime(10, 3, 2002), 16234.6D)) ;
    dataset.addData(0, createData(toLongTime(11, 3, 2002), 17232.299999999999D)) ;
    dataset.addData(0, createData(toLongTime(12, 3, 2002), 14232.200000000001D)) ;
    dataset.addData(0, createData(toLongTime(13, 3, 2002), 13102.200000000001D)) ;
    dataset.addData(0, createData(toLongTime(14, 3, 2002), 14230.200000000001D)) ;
    dataset.addData(0, createData(toLongTime(15, 3, 2002), 11235.200000000001D)) ;

    return dataset ;
  }

  private IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 2") ;

    dataset.addRowData() ;

    dataset.addData(0, new XYNumberChartData(toLongTime(3, 3, 2002), 16853.200000000001D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(4, 3, 2002), 19642.299999999999D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(5, 3, 2002), 18253.5D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(6, 3, 2002), 15352.299999999999D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(7, 3, 2002), 13532D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(8, 3, 2002), 12635.299999999999D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(9, 3, 2002), 13998.200000000001D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(10, 3, 2002), 11943.200000000001D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(11, 3, 2002), 16943.900000000001D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(12, 3, 2002), 17843.200000000001D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(13, 3, 2002), 16495.299999999999D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(14, 3, 2002), 17943.599999999999D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(15, 3, 2002), 18500.700000000001D)) ;
    dataset.addData(0, new XYNumberChartData(toLongTime(16, 3, 2002), 19595.900000000001D)) ;

    return dataset ;
  }

  private IntervalXYNumberChartData createData(long time, double value) {
    return new IntervalXYNumberChartData(time, time + 0.5 * one_day, 0, value) ;
  }

  private long toLongTime(int day, int month, int year) {
    cal.set(year, month - 1, day, 0, 0, 0) ;

    return cal.getTime().getTime() ;
  }

}
