package demo.timeseriescharts ;

import java.awt.GridLayout ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.IFormatter ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class RelativeDateFormatDemo1 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public RelativeDateFormatDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Exercise Chart", "Elapsed Time",
                                                           "Beats Per Minute", dataset,
                                                           orientation, true, true, true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    xyplot.setDomainCrosshairVisible(true) ;
    xyplot.setValueCrosshairVisible(true) ;

    XYNumberValueAxis xAxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    xAxis.setTickValueFormatter(new IFormatter() {
      private Calendar cal = Calendar.getInstance() ;

      public String format(Object obj, int index) {
        if (obj != null) {
          String str = obj.toString() ;
          cal.setTimeInMillis(Long.parseLong(str)) ;

          return cal.get(Calendar.HOUR) + "h" + cal.get(Calendar.MINUTE) + "m"
            + cal.get(Calendar.SECOND) + "s" ;
        }

        return null ;
      }
    }) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Heart Rate") ;

    dataset.addRowData() ;

    dataset.addData(0, createData(45, 6, 9, 1, 10, 2006, 143D)) ;
    dataset.addData(0, createData(33, 8, 9, 1, 10, 2006, 167D)) ;
    dataset.addData(0, createData(10, 10, 9, 1, 10, 2006, 189D)) ;
    dataset.addData(0, createData(19, 12, 9, 1, 10, 2006, 156D)) ;
    dataset.addData(0, createData(5, 15, 9, 1, 10, 2006, 176D)) ;
    dataset.addData(0, createData(12, 16, 9, 1, 10, 2006, 183D)) ;
    dataset.addData(0, createData(6, 18, 9, 1, 10, 2006, 138D)) ;
    dataset.addData(0, createData(11, 20, 9, 1, 10, 2006, 102D)) ;

    return dataset ;
  }

  private static XYNumberChartData createData(int second, int minute, int hour, int day, int month,
                                              int year, double value) {
    long mills = DateUtil.dateToTimeInMillis(year, month, day, hour, minute, second) ;
    return new XYNumberChartData(mills, value) ;
  }
}
