package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ˮƽķʽ,Һˮƽ.</zh>
 * <en>An enumeration of the alignment types (LEFT,RIGHT and HORIZONTAL_CENTER).</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class HorizontalAlignment implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = -293698320738077716L ;

  /**
   * <zh>.</zh>
   * <en>Left alignment.</en>
   */
  public static final HorizontalAlignment LEFT = new HorizontalAlignment("HORIZONTALAlignment.LEFT") ;

  /**
   * <zh>Ҷ.</zh>
   * <en>Right alignment.</en>
   */
  public static final HorizontalAlignment RIGHT = new HorizontalAlignment(
    "HorizontalAlignment.RIGHT") ;

  /**
   * <zh>ж.</zh>
   * <en>Center alignment.</en>
   */
  public static final HorizontalAlignment CENTER = new HorizontalAlignment(
    "HorizontalAlignment.CENTER") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private HorizontalAlignment(final String name) {
    this.name = name ;
  }

  /**
   * <zh>෴Ķ뷽ʽ.</zh>
   * <en>Returns the opposite horizontal alignment.</en>
   *
   * @param align HorizontalAlignment <zh>ˮƽ뷽ʽ (Ϊnull).</zh>
   * <en>The horizontal alignment.</en>
   *
   * @return HorizontalAlignment <zh>෴ˮƽ뷽ʽ (Ϊnull).</zh>
   * <en>The opposite horizontal alignment (never null).</en>
   */
  public static HorizontalAlignment getOpposite(HorizontalAlignment align) {
    if (align == null) {
      throw new IllegalArgumentException("Null 'align' argument.") ;
    }

    if (align.equals(HorizontalAlignment.LEFT)) {
      return HorizontalAlignment.RIGHT ;
    } else if (align.equals(HorizontalAlignment.CENTER)) {
      return HorizontalAlignment.CENTER ;
    } else if (align.equals(HorizontalAlignment.RIGHT)) {
      return HorizontalAlignment.LEFT ;
    }

    throw new IllegalArgumentException("Not available 'align' argument.") ;
  }

  /**
   * <zh>Ƿ,ȷtrue,򷵻false.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param obj <zh>ҪȽϵĶ (Ϊnull)</zh>
   * <en>The object (null permitted).</en>
   *
   * @return A boolean.
   */
  public boolean equals(final Object obj) {
    if (this == obj) {
      return true ;
    }
    if (!(obj instanceof HorizontalAlignment)) {
      return false ;
    }

    HorizontalAlignment that = (HorizontalAlignment) obj ;
    return this.name.equals(that.name) ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object.</en>
   *
   * @return <zh>hashcodeֵ.</zh>
   * <en>The hashcode.</en>
   */
  public int hashCode() {
    return this.name.hashCode() ;
  }

  /**
   * <zh>toString.</zh>
   * <en>Returns a string representing the object.</en>
   *
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

}
