package com.ijchart.xychart.format ;

import com.ijchart.xychart.dataset.IMatrixDataset ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ڸʽ{@link com.ijchart.xychart.data.IChartData}Ϊһַ.</zh>
 * <en>A Formatter provides support for formatting
 *  {@link com.ijchart.xychart.data.IChartData} Object.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public interface IChartDataFormatter {
  /**
   * <zh>ʽݼĳ{@link com.ijchart.xychart.data.IChartData}Ϊַ.</zh>
   * <en>Formatted an {@link com.ijchart.xychart.data.IChartData} object to a string.</en>
   *
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset (null not permitted).</en>
   * @param row int <zh>ݼ,ڵ0.</zh>
   * <en>The dataset row number,must be greater than or equal to 0.</en>
   * @param column int <zh>ݼ,ڵ0.</zh>
   * <en>The dataset column number,must be greater than or equal to 0.</en>
   *
   * @return String <zh>ַ (Ϊnull).</zh>
   * <en>A string (maybe null).</en>
   */
  String format(IMatrixDataset dataset, int row, int column) ;

  /**
   * <zh>ʽݼĳ{@link com.ijchart.xychart.data.IChartData}Ϊַ.</zh>
   * <en>Formatted an {@link com.ijchart.xychart.data.IChartData} object to a string.</en>
   *
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset (null not permitted).</en>
   * @param row int <zh>ݼ,ڵ0.</zh>
   * <en>The dataset row number,must be greater than or equal to 0.</en>
   * @param column int <zh>ݼ,ڵ0.</zh>
   * <en>The dataset column number,must be greater than or equal to 0.</en>
   * @param index int <zh>еһݵɶ,ֵʾ.</zh>
   * <en>The index of a dataset data.</en>
   *
   * @return String <zh>ַ (Ϊnull).</zh>
   * <en>A string (maybe null).</en>
   */
  String format(IMatrixDataset dataset, int row, int column, int index) ;
}
