package com.ijchart.xychart.ui ;

import java.awt.geom.Rectangle2D ;
import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ÿȺ͵ȱʾľ,ǲⲿ޸ĵ.</zh>
 * <en>Construct a rectangle by width and height,this class is immutable.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class Rectangle implements Serializable, Cloneable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = -4761440297707997171L ;

  /**
   * <zh>ͿΪ0ľ.</zh>
   * <en>A rectangle with width and height are all 0.</en>
   */
  public static final Rectangle RECTANGLE_ZERO = new Rectangle(0, 0) ;

  /**
   * <zh>.</zh>
   * <en>The width of this rectangle.</en>
   */
  private double width ;

  /**
   * <zh>߶.</zh>
   * <en>The height of this rectangle.</en>
   */
  private double height ;

  /**
   * <zh>ɿȺ͸߶ֵһ.</zh>
   * <en>Construct a rectangle by width and height.</en>
   * @param width double <zh>εĿ.</zh>
   * <en>The width of this rectangle.</en>
   * @param height double <zh>εĸ߶.</zh>
   * <en>The height of this rectangle.</en>
   */
  public Rectangle(double width, double height) {
    this.width = width ;
    this.height = height ;
  }

  /**
   * <zh>ؾεĿ.</zh>
   * <en>Returns the width of this rectangle.</en>
   * @return double <zh>εĿ.</zh>
   * <en>The width of this rectangle.</en>
   */
  public double getWidth() {
    return this.width ;
  }

  /**
   * <zh>ؾεĸ߶.</zh>
   * <en>Returns the height of this rectangle.</en>
   * @return double <zh>εĸ߶.</zh>
   * <en>The height of this rectangle.</en>
   */
  public double getHeight() {
    return this.height ;
  }

  /**
   * <zh>תΪjava.awt.geom.Rectangle2D,xy0.</zh>
   * <en>Construct a java.awt.geom.Rectangle2D;x=0,y=0.</en>
   *
   * @return Rectangle2D
   */
  public Rectangle2D toRectangle2D() {
    return new Rectangle2D.Double(0, 0, width, height) ;
  }

  /**
   * <zh>toString.</zh>
   * <en>Override toString method.</en>
   * @return String
   */
  public String toString() {
    return "[width=" + this.width
      + ",height=" + this.height
      + "]" ;
  }

  /**
   * <zh>hashCode.</zh>
   * <en>Override hashCode method.</en>
   * @return int
   */
  public int hashCode() {
    long bits = Double.doubleToLongBits(getWidth()) * 43 ;
    bits += Double.doubleToLongBits(getHeight()) * 47 ;

    return (((int) bits) ^ ((int) (bits >> 32))) ;
  }

  /**
   * <zh>equals.</zh>
   * <en>Override equals method.</en>
   * @param obj Object
   * @return boolean
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }

    if (!(obj instanceof Rectangle)) {
      return false ;
    }

    Rectangle other = (Rectangle) obj ;

    return this.width == other.width
      && this.height == other.height ;
  }

  /**
   * <zh>equals.</zh>
   * <en>Override equals method.</en>
   * @return Object
   * @throws CloneNotSupportedException
   */
  public Object clone() throws CloneNotSupportedException {
    return super.clone() ;
  }

}
